
# Climbing

This mod adds a new skill called **Climbing** to the game. It applies when running up a slope that is normally too steep to simply walk up it.

The mod works similar to the **Run** skill, in that the player doesn't get experience every step they climb. Instead, the player must climb some distance (configurable, see below) before they are awarded experience in the skill.

## Configuration

### General
***Lock Configuration*** - When this mod is installed on a server, and this setting is enabled, then the configuration is locked to the server configuration.

### Climbing Adjustments
***Skill Experience Distance Gain*** - this is the minimum distance on the vertical axis the player must climb before increasing their climbing counter towards gaining experience.
*default value:* 0.2
*min value:* 0.01
*max value:* 1

***Skill Experience Distance Reset*** - This is the minimum distance on the vertical axis the player must come back down before the climbing counter will once again increase when climbing. The intention is to prevent someone from running around in a small circle and getting skill ups, but this also allows forcing a player to come back down a considerable distance before getting experience when climbing up again. The default value is fairly low.
*default value:* 1
*min value:* 0.01
*max value:* 100

***Skill Experience Gain Factor*** - this controls how quickly players will gain experience when climbing. Each time a player climbs the required minimum distance, they will get this value added to the current climbing counter. Once the counter is at 1.00, they will gain experience in the skill. With a value of 1.00, every time a player climbs the required minimum distance, they will gain experience. This would result in really fast early skill-ups.
*default value:* 0.075
*min value:* 0.01
*max value:* 1

***Skill Experience Loss*** - the percentage of experience lost when the player dies.
*default value:* 5%
*min value:* 0%
*max value:* 100%

***Stamina Reduction Factor At Max Level*** - the percentage stamina use will be reduced by according to skill level. The mod uses linear interpolation to adjust the value based on skill level. This controls how much the reduction is at Skill Level = 100. Keep in mind that stamina usage is already being reduced by the **Run** skill.
*default value:* 34%
*min value:* 0%
*max value:* 100%

### Other
***Log Debug Messages*** - when enabled, this will log a message to the BepInEx console every time the player runs up a qualifying slope. Turning this on helps when you are tuning your configuration, but be aware this can result in a lot of log spam.

### Localization
This mod supports localization, so that you can translate the configuration, skill name and description, and debug messages into your Valheim supported language of choice. You can also send me the file if you wish for me to add it to the mod itself, so that everyone may use your translation. You can [send me a message at NexusMods](https://forums.nexusmods.com/index.php?/user/174078318-rabidwolfstudios/), or catch me on the Valheim Modding discord, I am logged in as **RabidWolfStudios**.

If you want to create your own translation, you can use the template found below and edit the text in “quotes” to the right of the colon (**:**) in your chosen language, and then save the file as Climbing.\<Language>.yml in the BepInEx config folder. The \<Language> in the filename should be in English. For example, to translate into Russian, you would name the file “Climbing.Russian.yml”.

#### Languages built into the mod:

 - English
 - Russian

#### English Language Template

    rw_climbing_skill_name: “Climbing”
    rw_climbing_skill_description: “Allows you to lose less stamina when running up sloped terrain”
    rw_climbing_debug_message: “Climbing skill factor is: {0} - Reducing stamina use by: {1}% - From {2} to {3} - Percent towards next experience increase {4}”
    rw_climbing_config_category_general: “1 - General”
    rw_climbing_config_category_adjustments: “2 - Climbing Adjustments”
    rw_climbing_config_category_other: “3 - Other”
    rw_climbing_config_lock_configuration_name: “Lock Configuration”
    rw_climbing_config_lock_configuration_description: “If on, the configuration is locked and can be changed by server admins only.”
    rw_climbing_config_skill_experience_gain_factor_name: “Skill Experience Gain Factor”
    rw_climbing_config_skill_experience_gain_factor_description: “Factor for experience gained for the climbing skill (Default ={0})”
    rw_climbing_config_skill_experience_loss_name: “Skill Experience Loss”
    rw_climbing_config_skill_experience_loss_description: “How much experience to lose in the climbing skill on death (Default = {0})”
    rw_climbing_config_skill_experience_distance_gain_name: “Skill Experience Distance Gain”
    rw_climbing_config_skill_experience_distance_gain_description: “Distance player must run up slope to gain experience (Default = {0})”
    rw_climbing_config_skill_experience_distance_reset_name: “Skill Experience Distance Reset”
    rw_climbing_config_skill_experience_distance_reset_description: “Distance player must come back down a slope from their most recent highest point that gained experience before they gain experience once more running up a slope (Default = {0})”
    rw_climbing_config_stamina_reduction_factor_name: “Stamina Reduction Factor At Max Level”
    rw_climbing_config_stamina_reduction_factor_description: “Maximum stamina reduction at Skill Level 100. The amount of stamina usage to reduce by when climbing. (Default = {0}”
    rw_climbing_config_log_debug_messages_name: “Log Debug Messages”
    rw_climbing_config_log_debug_messages_description: “Log debug messages to BepInEx log? This can result in a lot of log spam”

## Credits and Acknowledgements
* [Smoothbrain](https://github.com/blaxxun-boop/) - for creating the [SkillManager](https://github.com/blaxxun-boop/SkillManager) framework and providing multiple skills with source code to learn from
* [Kazuals Discord Community](https://discord.gg/aWSJbq2hZz) - for providing a fantastic modded experience and a welcoming community for players.
* GrassTastesBad - This mod was his idea, and he is an admin of the aforementioned modded server. 
* [biatlonist76biatlonist](https://forums.nexusmods.com/index.php?/user/81246478-biatlonist76biatlonist/) - For providing the Russian language translation